using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net.Sockets;
using System.Threading;
using SKYPE4COMLib;
using Microsoft.Win32;


namespace SkypeServer
{
    public partial class settings : Form
    {
        public Skype skype = new Skype();
        public SKYPE4COMLib.SkypeClass cSkype;
        
        public settings()
        {
            
            InitializeComponent();
            this.Resize += new EventHandler(settings_Resize);
            ni.DoubleClick += new EventHandler(ni_DoubleClick);
            skype.CallStatus += new _ISkypeEvents_CallStatusEventHandler(skype_CallStatus);

            
            Start();
        }

        void skype_CallStatus(Call pCall, TCallStatus Status)
        {
            string response = "";
            if ((Status == TCallStatus.clsRinging) && ((pCall.Type == TCallType.cltIncomingP2P) || (pCall.Type == TCallType.cltIncomingPSTN))) response = Send(pCall.PartnerDisplayName, pCall.PartnerHandle, pCall.Timestamp.ToString());
            if (response == "YES") pCall.Answer();
            else if (response == "NO") pCall.Finish();
            
        }

        void ni_DoubleClick(object sender, EventArgs e)
        {
            Show();
            WindowState = FormWindowState.Normal;
        }

        void settings_Resize(object sender, EventArgs e)
        {
            if (FormWindowState.Minimized == WindowState)
                Hide();
        }

        void ConnectCOM()
        {

            try
            {
                
                skype.Attach(7, true);
  
            }
            catch (System.Runtime.InteropServices.COMException eek)
            {
                MessageBox.Show("Couldn't connect to Skype COM control\r\n" + eek.Message, "Couldn't connect");
                ni.Dispose();
                Environment.Exit(0);
            }
        }
        public void Start()
        {
            //Thread tr = new Thread(new ThreadStart(ConnectCOM));
            //tr.IsBackground = true;
            //tr.Start();
            RegistryKey rk = Registry.CurrentUser.CreateSubKey(@"SOFTWARE\Jonathan Kay\SkypeServer");
            txtHost.Text = (string)rk.GetValue("host", "127.0.0.1");
            txtPort.Text = (string)rk.GetValue("port", "58211");
            ConnectCOM();
        }


        private string Send(string pname,string phandle,string pstamp) {
            try
            {
                TcpClient tcpc = new TcpClient();
                tcpc.Connect(txtHost.Text, Convert.ToInt32(txtPort.Text));
                tcpc.SendTimeout = 3000;
                tcpc.ReceiveTimeout = 20000;
                NetworkStream ns = tcpc.GetStream();
                if (ns.CanWrite)
                {
                    Byte[] sB = Encoding.UTF8.GetBytes("RNG|" + pname + "|" + phandle + "|" + pstamp);
                    ns.Write(sB, 0, sB.Length);
                }
                else
                {
                    ni.ShowBalloonTip(30, "Unable to send", "Notification of this call could not be sent.", ToolTipIcon.Error);
                    tcpc.Close();
                    ns.Close();
                    return "";
                }

                if (ns.CanRead)
                {
                    byte[] bytes = new byte[tcpc.ReceiveBufferSize];
                    ns.Read(bytes, 0, (int)tcpc.ReceiveBufferSize);
                    string returndata = Encoding.UTF8.GetString(bytes);
                    ns.Close();
                    return returndata.Replace("\0","");
                    
                    
                }
                else
                {
                    ni.ShowBalloonTip(30, "Couldn't read response", "A response to the call notification could not be read.", ToolTipIcon.Error);
                    tcpc.Close();
                    ns.Close();
                    return "";
                }
                ns.Close();
                return "";
            }
            catch (System.IO.IOException ioeek)
            {
                ni.ShowBalloonTip(30, "No response detected", "No response to the request was detected", ToolTipIcon.Info);
                return "";
            }
            catch (Exception eek)
            {
                ni.ShowBalloonTip(30, "Error", eek.Message, ToolTipIcon.Error);
                return "";
            }
            
        }

        private void btnTest_Click(object sender, EventArgs e)
        {
            Send("test name","testhandle",DateTime.Now.ToString());
        }

        private void settingsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Show();
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ni.Dispose();
            System.Windows.Forms.Application.Exit();
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            RegistryKey rk = Registry.CurrentUser.CreateSubKey(@"SOFTWARE\Jonathan Kay\SkypeServer");
            rk.SetValue("host", txtHost.Text);
            rk.SetValue("port", txtPort.Text);
            Hide();
        }
    }


}